package com.zipcodewilmington.generic.group;

import com.zipcodewilmington.generic.identifiables.IdentifiableInterface;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.function.Predicate;
import java.util.function.Predicate;
import java.util.function.Supplier;
import java.util.stream.Collectors;

/**
 * @author leon on 06/12/2018.
 */
public class Group<TypeOfId extends Serializable ,TypeOfEntity extends IdentifiableInterface<TypeOfId>>
        extends AbstractGroup<TypeOfId, TypeOfEntity>
{
    private ArrayList<TypeOfEntity> list;

public Group()
        {
        this.list = new ArrayList<>();
        }


@Override
    public Integer count() {
        return list.size();
    }

    @Override
    public void insert(IdentifiableInterface object)
    {
        list.add((TypeOfEntity) object);
    }

    @Override
    public void delete(IdentifiableInterface object)
    {
        list.remove(object);
    }

    @Override
    public void delete(Serializable serializable)
    {
        Iterator iterator = list.iterator();
        while (iterator.hasNext()){
            IdentifiableInterface next = (IdentifiableInterface) iterator.next();
            if(next.getIdentity().equals(serializable)) iterator.remove();
        }

    }

    @Override
    public Boolean has(IdentifiableInterface object) {
        for (IdentifiableInterface id : list) {
            if (list.contains(id)) return true;
        }
        return false;
    }

    @Override
    public Boolean has(Serializable serializable) {
        Iterator iterator = list.iterator();
        while (iterator.hasNext()){
            IdentifiableInterface next = (IdentifiableInterface) iterator.next();
            if(next.getIdentity().equals(serializable)) return true;
        }
        return false;
    }

    @Override
    public List filter(Predicate predicate) {
        return (ArrayList<TypeOfEntity>)list.stream()
                .filter(predicate)
                .collect(Collectors.toList());
    }

    @Override
    public Class getIdentityType() {
        return list.getClass();
    }

    @Override
    public Class getIdentifiableType() {
        return this.getClass().getEnclosingClass();
    }

}
